(function(app) {
  app.BooksComponent = ng.core
    .Component({
      selector: 'book-list',
      templateUrl: 'books.html',
      providers: [ng.http.HTTP_PROVIDERS, app.BooksService, app.BooksSortPipe]
    })
    .Class({
      constructor: [app.BooksService, app.BooksSortPipe,
      function(_booksService, _booksSortPipe) {
        this.books = [];
        this.message = '';               
        this.service = _booksService;
        this.sortPipe = _booksSortPipe;
      }],
      getBooks: function() {
        this.service.get()
                    .subscribe(
                      this.updateBooks.bind(this),
                      this.updateError.bind(this));        
      },
      updateBooks: function(books) {
        this.books = this.sortPipe.transform(books);
      },
      updateError: function(message) {
        this.message = message;
      },
      ngOnInit: function() {
        this.getBooks();
      }
    });
})(window.app || (window.app = {}));