(function(app) {
  app.BooksService = ng.core.Class({
    constructor: [ng.http.Http, function(_http) {
      this.http = _http;
    }],
    get: function() {
      return this.http.get('/books')
                      .map(this.extractData)
                      .catch(this.returnError);
    },
    extractData: function(response) {
      if(response.status !== 200)
        throw new Error("Error, status: " + response.status)
      return response.json();
    },
    returnError: function(error) {
      return Rx.Observable.throw(error.message || "Error: request failed");
    }
  });
})(window.app || (window.app = {}));