describe('books sort pipe test', function() {
  var pipe;
  
  beforeEach(function() {
    pipe = new app.BooksSortPipe();
  });
  
  it('should sort books by name', function() {
    var books = [
      {id: 1, name: 'Test Driven Development: By Example', author: 'Kent Beck', publisher: 'Addison-Wesley', link: 'http://www.amazon.com/Test-Driven-Development-Kent-Beck/dp/0321146530'},
      {id: 2, name: 'JavaScript: The Good Parts', author: 'Douglas Crockford', publisher: "O'Reilly", link: 'http://shop.oreilly.com/product/9780596517748.do'},
      {id: 3, name: 'Test-Driving JavaScript Applications: Rapid, Confident, Maintainable Code', author: 'Venkat Subramaniam', publisher: 'The Pragmatic Programmers', link: 'https://pragprog.com/book/vsjavas'}
    ];   
   
   var sorted = pipe.transform(books);
   
   expect(sorted[0]).to.be.eql(books[1]);
   expect(sorted[1]).to.be.eql(books[0]);
   expect(sorted[2]).to.be.eql(books[2]);
  });             
  
  //... more tests on transform ...
  
  it('should have a name', function() {
    var annotations = 
      Reflect.getMetadata("annotations", app.BooksSortPipe)[0];
      
    expect(annotations.name).to.be.eql('sort');
  });
});